diff -urN ../v2.2.21-ds8/linux/include/linux/pkt_sched.h linux/include/linux/pkt_sched.h
--- ../v2.2.21-ds8/linux/include/linux/pkt_sched.h	Wed Jul 31 03:00:59 2002
+++ linux/include/linux/pkt_sched.h	Sun Aug  4 17:54:40 2002
@@ -189,6 +189,16 @@
 	unsigned char   Wlog;		/* log(W)		*/
 	unsigned char   Plog;		/* log(P_max/(qth_max-qth_min))	*/
 	unsigned char   Scell_log;	/* cell size for idle damping */
+	unsigned char	flags;
+#define TC_RED_ECN	1
+};
+
+struct tc_red_xstats
+{
+	__u32           early;          /* Early drops */
+	__u32           pdrop;          /* Drops due to queue limits */
+	__u32           other;          /* Drops due to drop() calls */
+	__u32           marked;         /* Marked packets */
 };
 
 /* GRED section */
diff -urN ../v2.2.21-ds8/linux/include/net/pkt_cls.h linux/include/net/pkt_cls.h
--- ../v2.2.21-ds8/linux/include/net/pkt_cls.h	Sat Oct 21 15:11:28 2000
+++ linux/include/net/pkt_cls.h	Thu Aug  1 03:12:52 2002
@@ -77,16 +77,6 @@
 	return -1;
 }
 
-extern __inline__ unsigned long cls_set_class(unsigned long *clp, unsigned long cl)
-{
-	unsigned long old_cl; 
-
-	old_cl = *clp;
-	*clp = cl;
-	synchronize_bh();
-	return old_cl;
-}
-
 extern int register_tcf_proto_ops(struct tcf_proto_ops *ops);
 extern int unregister_tcf_proto_ops(struct tcf_proto_ops *ops);
 
diff -urN ../v2.2.21-ds8/linux/include/net/pkt_sched.h linux/include/net/pkt_sched.h
--- ../v2.2.21-ds8/linux/include/net/pkt_sched.h	Wed Jul 31 03:00:59 2002
+++ linux/include/net/pkt_sched.h	Wed Aug  7 03:23:36 2002
@@ -8,6 +8,7 @@
 #define PSCHED_CLOCK_SOURCE	PSCHED_JIFFIES
 
 #include <linux/pkt_sched.h>
+#include <linux/ip.h>
 #include <net/pkt_cls.h>
 
 struct rtattr;
@@ -78,6 +79,7 @@
 	unsigned		flags;
 #define TCQ_F_BUILTIN	1
 #define TCQ_F_THROTTLED	2
+#define TCQ_F_INGRES	4
 	struct Qdisc_ops	*ops;
 	struct Qdisc		*next;
 	u32			handle;
@@ -85,7 +87,6 @@
 	struct sk_buff_head	q;
 	struct device 		*dev;
 
-        int                     ingress;
 	struct tc_stats		stats;
 	unsigned long		tx_timeo;
 	unsigned long		tx_last;
@@ -107,6 +108,111 @@
 	int		refcnt;
 };
 
+#ifndef MODULE_LICENSE
+#define MODULE_LICENSE(X)
+#endif
+
+#ifndef NET_XMIT_SUCCESS
+#define NET_XMIT_SUCCESS	0
+#define NET_XMIT_DROP		1	/* skb dropped			*/
+#define NET_XMIT_CN		2	/* congestion notification	*/
+#define NET_XMIT_POLICED	3	/* skb is shot by police	*/
+#define NET_XMIT_BYPASS		4	/* packet does not leave via dequeue;
+					   (TC use only - dev_queue_xmit
+					   returns this as NET_XMIT_SUCCESS) */
+#endif
+
+#define likely(e)	(e)
+#define unlikely(e)	(e)
+
+#ifndef min_t
+#define min_t(type,x,y) \
+	({ type __x = (x); type __y = (y); __x < __y ? __x: __y; })
+#define max_t(type,x,y) \
+	({ type __x = (x); type __y = (y); __x > __y ? __x: __y; })
+#endif
+
+static inline void list_del_init(struct list_head *entry)
+{
+	__list_del(entry->prev, entry->next);
+	INIT_LIST_HEAD(entry);
+}
+
+static inline void __skb_queue_purge(struct sk_buff_head *list)
+{
+	struct sk_buff *skb;
+	while ((skb=__skb_dequeue(list))!=NULL)
+		kfree_skb(skb);
+}
+#define del_timer_sync(t) del_timer(t)
+
+#define netif_schedule qdisc_wakeup
+#define netif_queue_stopped(D) (D->tbusy)
+#ifndef BUG_TRAP
+#define BUG_TRAP(x) if (!(x)) { printk("Assertion (" #x ") failed at " __FILE__ "(%d):" __FUNCTION__ "\n", __LINE__); }
+#endif
+
+static inline void IP_ECN_set_ce(struct iphdr *iph)
+{
+	u32 check = iph->check;
+	check += __constant_htons(0xFFFE);
+	iph->check = check + (check>=0xFFFF);
+	iph->tos |= 1;
+}
+
+static inline void sch_tree_lock(struct Qdisc *q)
+{
+	start_bh_atomic();
+}
+
+static inline void sch_tree_unlock(struct Qdisc *q)
+{
+	end_bh_atomic();
+}
+
+static inline void tcf_tree_lock(struct tcf_proto *tp)
+{
+	wmb();
+}
+
+static inline void tcf_tree_unlock(struct tcf_proto *tp)
+{
+	synchronize_bh();
+}
+
+static inline void sch_dev_queue_lock(struct device *dev)
+{
+	start_bh_atomic();
+}
+
+static inline void sch_dev_queue_unlock(struct device *dev)
+{
+	end_bh_atomic();
+}
+
+
+static inline unsigned long
+cls_set_class(struct tcf_proto *tp, unsigned long *clp, unsigned long cl)
+{
+	unsigned long old_cl;
+
+	old_cl = *clp;
+	wmb();
+	*clp = cl;
+	synchronize_bh();
+	return old_cl;
+}
+
+static inline unsigned long
+__cls_set_class(unsigned long *clp, unsigned long cl)
+{
+	unsigned long old_cl;
+
+	old_cl = *clp;
+	*clp = cl;
+	return old_cl;
+}
+
 
 /* 
    Timer resolution MUST BE < 10% of min_schedulable_packet_size/bandwidth
@@ -177,7 +283,7 @@
 
 #define PSCHED_EXPORTLIST_2
 
-#if ~0UL == 0xFFFFFFFF
+#if BITS_PER_LONG <= 32
 
 #define PSCHED_WATCHER unsigned long
 
@@ -208,7 +314,7 @@
 
 #define PSCHED_US2JIFFIE(delay) (((delay)+psched_clock_per_hz-1)/psched_clock_per_hz)
 
-#if CPU == 586 || CPU == 686
+#ifdef CONFIG_X86_TSC
 
 #define PSCHED_GET_TIME(stamp) \
 ({ u64 __cur; \
@@ -314,8 +420,8 @@
 #define PSCHED_TDIFF(tv1, tv2) (long)((tv1) - (tv2))
 #define PSCHED_TDIFF_SAFE(tv1, tv2, bound, guard) \
 ({ \
-	   long __delta = (tv1) - (tv2); \
-	   if ( __delta > (bound)) {  __delta = (bound); guard; } \
+	   long long __delta = (tv1) - (tv2); \
+	   if ( __delta > (long long)(bound)) {  __delta = (bound); guard; } \
 	   __delta; \
 })
 
@@ -350,6 +456,7 @@
 	struct tc_stats	stats;
 };
 
+extern int qdisc_copy_stats(struct sk_buff *skb, struct tc_stats *st);
 extern void tcf_police_destroy(struct tcf_police *p);
 extern struct tcf_police * tcf_police_locate(struct rtattr *rta, struct rtattr *est);
 extern int tcf_police_dump(struct sk_buff *skb, struct tcf_police *p);
diff -urN ../v2.2.21-ds8/linux/net/core/skbuff.c linux/net/core/skbuff.c
--- ../v2.2.21-ds8/linux/net/core/skbuff.c	Wed Jul 31 03:00:59 2002
+++ linux/net/core/skbuff.c	Sun Aug  4 16:18:42 2002
@@ -310,6 +310,9 @@
 #ifdef CONFIG_IP_FIREWALL
         n->fwmark = skb->fwmark;
 #endif
+#ifdef CONFIG_NET_SCHED
+	n->tc_index = skb->tc_index;
+#endif
 	return n;
 }
 
@@ -358,6 +361,9 @@
 	n->security=skb->security;
 #ifdef CONFIG_IP_FIREWALL
         n->fwmark = skb->fwmark;
+#endif
+#ifdef CONFIG_NET_SCHED
+	n->tc_index = skb->tc_index;
 #endif
 
 	return n;
diff -urN ../v2.2.21-ds8/linux/net/ipv4/ip_input.c linux/net/ipv4/ip_input.c
--- ../v2.2.21-ds8/linux/net/ipv4/ip_input.c	Wed Jul 31 03:00:59 2002
+++ linux/net/ipv4/ip_input.c	Tue Aug  6 14:02:54 2002
@@ -151,7 +151,7 @@
 #include <linux/netlink.h>
 
 #ifdef	CONFIG_FIREWALL
-#ifdef CONFIG_NET_SCH_INGRESS
+#if defined(CONFIG_NET_SCH_INGRESS) || defined(CONFIG_NET_SCH_INGRESS_MODULE)
 #include <net/pkt_sched.h>
 #endif
 #endif
@@ -475,9 +475,8 @@
 	fwres = call_in_firewall(PF_INET, dev, iph, &rport, &skb);
 	if (fwres < FW_ACCEPT && fwres != FW_REJECT)
 		goto drop;
-#ifdef CONFIG_NET_SCH_INGRESS
-        fwres = call_in_ingress(skb);
-        if (fwres != FW_ACCEPT)
+#if defined(CONFIG_NET_SCH_INGRESS) || defined(CONFIG_NET_SCH_INGRESS_MODULE)
+        if (FW_ACCEPT != call_in_ingress(skb))
                 goto drop;
 #endif
 
diff -urN ../v2.2.21-ds8/linux/net/netsyms.c linux/net/netsyms.c
--- ../v2.2.21-ds8/linux/net/netsyms.c	Wed Jul 31 03:00:59 2002
+++ linux/net/netsyms.c	Tue Aug  6 13:40:17 2002
@@ -548,6 +548,7 @@
 EXPORT_SYMBOL(unregister_qdisc);
 EXPORT_SYMBOL(qdisc_get_rtab);
 EXPORT_SYMBOL(qdisc_put_rtab);
+EXPORT_SYMBOL(qdisc_copy_stats);
 #ifdef CONFIG_NET_ESTIMATOR
 EXPORT_SYMBOL(qdisc_new_estimator);
 EXPORT_SYMBOL(qdisc_kill_estimator);
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_api.c linux/net/sched/cls_api.c
--- ../v2.2.21-ds8/linux/net/sched/cls_api.c	Wed Jul 31 03:00:59 2002
+++ linux/net/sched/cls_api.c	Sun Aug  4 19:57:48 2002
@@ -217,8 +217,10 @@
 			kfree(tp);
 			goto errout;
 		}
+		sch_dev_queue_lock(dev);
 		tp->next = *back;
 		*back = tp;
+		sch_dev_queue_unlock(dev);
 	} else if (tca[TCA_KIND-1] && rtattr_strcmp(tca[TCA_KIND-1], tp->ops->kind))
 		goto errout;
 
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_fw.c linux/net/sched/cls_fw.c
--- ../v2.2.21-ds8/linux/net/sched/cls_fw.c	Sat Oct 21 15:10:57 2000
+++ linux/net/sched/cls_fw.c	Thu Aug  1 03:34:59 2002
@@ -136,7 +136,7 @@
 			unsigned long cl;
 			head->ht[h] = f->next;
 
-			if ((cl = cls_set_class(&f->res.class, 0)) != 0)
+			if ((cl = __cls_set_class(&f->res.class, 0)) != 0)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 #ifdef CONFIG_NET_CLS_POLICE
 			tcf_police_release(f->police);
@@ -161,10 +161,11 @@
 		if (*fp == f) {
 			unsigned long cl;
 
+			tcf_tree_lock(tp);
 			*fp = f->next;
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
-			if ((cl = cls_set_class(&f->res.class, 0)) != 0)
+			if ((cl = cls_set_class(tp, &f->res.class, 0)) != 0)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 #ifdef CONFIG_NET_CLS_POLICE
 			tcf_police_release(f->police);
@@ -203,7 +204,7 @@
 
 			f->res.classid = *(u32*)RTA_DATA(tb[TCA_FW_CLASSID-1]);
 			cl = tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid);
-			cl = cls_set_class(&f->res.class, cl);
+			cl = cls_set_class(tp, &f->res.class, cl);
 			if (cl)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 		}
@@ -211,8 +212,9 @@
 		if (tb[TCA_FW_POLICE-1]) {
 			struct tcf_police *police = tcf_police_locate(tb[TCA_FW_POLICE-1], tca[TCA_RATE-1]);
 
+			tcf_tree_lock(tp);
 			police = xchg(&f->police, police);
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
 			tcf_police_release(police);
 		}
@@ -229,8 +231,9 @@
 			return -ENOBUFS;
 		memset(head, 0, sizeof(*head));
 
+		tcf_tree_lock(tp);
 		tp->root = head;
-		synchronize_bh();
+		tcf_tree_unlock(tp);
 	}
 
 	f = kmalloc(sizeof(struct fw_filter), GFP_KERNEL);
@@ -245,7 +248,7 @@
 		if (RTA_PAYLOAD(tb[TCA_FW_CLASSID-1]) != 4)
 			goto errout;
 		f->res.classid = *(u32*)RTA_DATA(tb[TCA_FW_CLASSID-1]);
-		cls_set_class(&f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
+		cls_set_class(tp, &f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
 	}
 
 #ifdef CONFIG_NET_CLS_POLICE
@@ -254,8 +257,9 @@
 #endif
 
 	f->next = head->ht[fw_hash(handle)];
-	wmb();
+	tcf_tree_lock(tp);
 	head->ht[fw_hash(handle)] = f;
+	tcf_tree_unlock(tp);
 
 	*arg = (unsigned long)f;
 	return 0;
@@ -294,7 +298,6 @@
 	}
 }
 
-#ifdef CONFIG_RTNETLINK
 static int fw_dump(struct tcf_proto *tp, unsigned long fh,
 		   struct sk_buff *skb, struct tcmsg *t)
 {
@@ -335,7 +338,8 @@
 	rta->rta_len = skb->tail - b;
 #ifdef CONFIG_NET_CLS_POLICE
 	if (f->police) {
-		RTA_PUT(skb, TCA_STATS, sizeof(struct tc_stats), &f->police->stats);
+		if (qdisc_copy_stats(skb, &f->police->stats))
+			goto rtattr_failure;
 	}
 #endif
 	return skb->len;
@@ -344,8 +348,6 @@
 	skb_trim(skb, b - skb->data);
 	return -1;
 }
-#endif
-
 
 struct tcf_proto_ops cls_fw_ops = {
 	NULL,
@@ -359,11 +361,7 @@
 	fw_change,
 	fw_delete,
 	fw_walk,
-#ifdef CONFIG_RTNETLINK
 	fw_dump
-#else
-	NULL
-#endif
 };
 
 #ifdef MODULE
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_route.c linux/net/sched/cls_route.c
--- ../v2.2.21-ds8/linux/net/sched/cls_route.c	Sat Oct 21 15:10:50 2000
+++ linux/net/sched/cls_route.c	Sun Aug  4 20:08:47 2002
@@ -83,11 +83,11 @@
 	return id&0xF;
 }
 
-static void route4_reset_fastmap(struct route4_head *head, u32 id)
+static void route4_reset_fastmap(struct device *dev, struct route4_head *head, u32 id)
 {
-	start_bh_atomic();
+	sch_dev_queue_lock(dev);
 	memset(head->fastmap, 0, sizeof(head->fastmap));
-	end_bh_atomic();
+	sch_dev_queue_unlock(dev);
 }
 
 static void __inline__
@@ -297,7 +297,7 @@
 					unsigned long cl;
 
 					b->ht[h2] = f->next;
-					if ((cl = cls_set_class(&f->res.class, 0)) != 0)
+					if ((cl = __cls_set_class(&f->res.class, 0)) != 0)
 						tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 #ifdef CONFIG_NET_CLS_POLICE
 					tcf_police_release(f->police);
@@ -316,25 +316,27 @@
 {
 	struct route4_head *head = (struct route4_head*)tp->root;
 	struct route4_filter **fp, *f = (struct route4_filter*)arg;
-	unsigned h = f->handle;
+	unsigned h = 0;
 	struct route4_bucket *b;
 	int i;
 
 	if (!head || !f)
 		return -EINVAL;
 
+	h = f->handle;
 	b = f->bkt;
 
 	for (fp = &b->ht[from_hash(h>>16)]; *fp; fp = &(*fp)->next) {
 		if (*fp == f) {
 			unsigned long cl;
 
+			tcf_tree_lock(tp);
 			*fp = f->next;
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
-			route4_reset_fastmap(head, f->id);
+			route4_reset_fastmap(tp->q->dev, head, f->id);
 
-			if ((cl = cls_set_class(&f->res.class, 0)) != 0)
+			if ((cl = cls_set_class(tp, &f->res.class, 0)) != 0)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 
 #ifdef CONFIG_NET_CLS_POLICE
@@ -349,8 +351,9 @@
 					return 0;
 
 			/* OK, session has no flows */
+			tcf_tree_lock(tp);
 			head->table[to_hash(h)] = NULL;
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
 			kfree(b);
 			return 0;
@@ -387,7 +390,7 @@
 			unsigned long cl;
 
 			f->res.classid = *(u32*)RTA_DATA(tb[TCA_ROUTE4_CLASSID-1]);
-			cl = cls_set_class(&f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
+			cl = cls_set_class(tp, &f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
 			if (cl)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 		}
@@ -395,8 +398,9 @@
 		if (tb[TCA_ROUTE4_POLICE-1]) {
 			struct tcf_police *police = tcf_police_locate(tb[TCA_ROUTE4_POLICE-1], tca[TCA_RATE-1]);
 
+			tcf_tree_lock(tp);
 			police = xchg(&f->police, police);
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
 			tcf_police_release(police);
 		}
@@ -412,8 +416,9 @@
 			return -ENOBUFS;
 		memset(head, 0, sizeof(struct route4_head));
 
+		tcf_tree_lock(tp);
 		tp->root = head;
-		synchronize_bh();
+		tcf_tree_unlock(tp);
 	}
 
 	f = kmalloc(sizeof(struct route4_filter), GFP_KERNEL);
@@ -475,8 +480,9 @@
 			goto errout;
 		memset(b, 0, sizeof(*b));
 
+		tcf_tree_lock(tp);
 		head->table[h1] = b;
-		synchronize_bh();
+		tcf_tree_unlock(tp);
 	}
 	f->bkt = b;
 
@@ -489,17 +495,18 @@
 			goto errout;
 	}
 
-	cls_set_class(&f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
+	cls_set_class(tp, &f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
 #ifdef CONFIG_NET_CLS_POLICE
 	if (tb[TCA_ROUTE4_POLICE-1])
 		f->police = tcf_police_locate(tb[TCA_ROUTE4_POLICE-1], tca[TCA_RATE-1]);
 #endif
 
 	f->next = f1;
-	wmb();
+	tcf_tree_lock(tp);
 	*ins_f = f;
+	tcf_tree_unlock(tp);
 
-	route4_reset_fastmap(head, f->id);
+	route4_reset_fastmap(tp->q->dev, head, f->id);
 	*arg = (unsigned long)f;
 	return 0;
 
@@ -543,7 +550,6 @@
 	}
 }
 
-#ifdef CONFIG_RTNETLINK
 static int route4_dump(struct tcf_proto *tp, unsigned long fh,
 		       struct sk_buff *skb, struct tcmsg *t)
 {
@@ -589,7 +595,8 @@
 	rta->rta_len = skb->tail - b;
 #ifdef CONFIG_NET_CLS_POLICE
 	if (f->police) {
-		RTA_PUT(skb, TCA_STATS, sizeof(struct tc_stats), &f->police->stats);
+		if (qdisc_copy_stats(skb, &f->police->stats))
+			goto rtattr_failure;
 	}
 #endif
 	return skb->len;
@@ -598,7 +605,6 @@
 	skb_trim(skb, b - skb->data);
 	return -1;
 }
-#endif
 
 struct tcf_proto_ops cls_route4_ops = {
 	NULL,
@@ -612,11 +618,7 @@
 	route4_change,
 	route4_delete,
 	route4_walk,
-#ifdef CONFIG_RTNETLINK
 	route4_dump
-#else
-	NULL
-#endif
 };
 
 #ifdef MODULE
@@ -630,3 +632,4 @@
 	unregister_tcf_proto_ops(&cls_route4_ops);
 }
 #endif
+MODULE_LICENSE("GPL");
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_rsvp.c linux/net/sched/cls_rsvp.c
--- ../v2.2.21-ds8/linux/net/sched/cls_rsvp.c	Thu Apr 30 08:46:59 1998
+++ linux/net/sched/cls_rsvp.c	Tue Nov 13 03:29:33 2001
@@ -39,3 +39,4 @@
 #define RSVP_OPS	cls_rsvp_ops
 
 #include "cls_rsvp.h"
+MODULE_LICENSE("GPL");
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_rsvp.h linux/net/sched/cls_rsvp.h
--- ../v2.2.21-ds8/linux/net/sched/cls_rsvp.h	Sat Oct 21 15:10:57 2000
+++ linux/net/sched/cls_rsvp.h	Sun Mar 31 06:18:28 2002
@@ -282,7 +282,7 @@
 					unsigned long cl;
 
 					s->ht[h2] = f->next;
-					if ((cl = cls_set_class(&f->res.class, 0)) != 0)
+					if ((cl = __cls_set_class(&f->res.class, 0)) != 0)
 						tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 #ifdef CONFIG_NET_CLS_POLICE
 					tcf_police_release(f->police);
@@ -310,10 +310,11 @@
 			unsigned long cl;
 
 
+			tcf_tree_lock(tp);
 			*fp = f->next;
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
-			if ((cl = cls_set_class(&f->res.class, 0)) != 0)
+			if ((cl = cls_set_class(tp, &f->res.class, 0)) != 0)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 
 #ifdef CONFIG_NET_CLS_POLICE
@@ -332,8 +333,9 @@
 			for (sp = &((struct rsvp_head*)tp->root)->ht[h&0xFF];
 			     *sp; sp = &(*sp)->next) {
 				if (*sp == s) {
+					tcf_tree_lock(tp);
 					*sp = s->next;
-					synchronize_bh();
+					tcf_tree_unlock(tp);
 
 					kfree(s);
 					return 0;
@@ -446,7 +448,7 @@
 			unsigned long cl;
 
 			f->res.classid = *(u32*)RTA_DATA(tb[TCA_RSVP_CLASSID-1]);
-			cl = cls_set_class(&f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
+			cl = cls_set_class(tp, &f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
 			if (cl)
 				tp->q->ops->cl_ops->unbind_tcf(tp->q, cl);
 		}
@@ -454,8 +456,9 @@
 		if (tb[TCA_RSVP_POLICE-1]) {
 			struct tcf_police *police = tcf_police_locate(tb[TCA_RSVP_POLICE-1], tca[TCA_RATE-1]);
 
+			tcf_tree_lock(tp);
 			police = xchg(&f->police, police);
-			synchronize_bh();
+			tcf_tree_unlock(tp);
 
 			tcf_police_release(police);
 		}
@@ -536,7 +539,7 @@
 
 			f->sess = s;
 			if (f->tunnelhdr == 0)
-				cls_set_class(&f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
+				cls_set_class(tp, &f->res.class, tp->q->ops->cl_ops->bind_tcf(tp->q, base, f->res.classid));
 #ifdef CONFIG_NET_CLS_POLICE
 			if (tb[TCA_RSVP_POLICE-1])
 				f->police = tcf_police_locate(tb[TCA_RSVP_POLICE-1], tca[TCA_RATE-1]);
@@ -612,7 +615,6 @@
 	}
 }
 
-#ifdef CONFIG_RTNETLINK
 static int rsvp_dump(struct tcf_proto *tp, unsigned long fh,
 		     struct sk_buff *skb, struct tcmsg *t)
 {
@@ -659,7 +661,8 @@
 	rta->rta_len = skb->tail - b;
 #ifdef CONFIG_NET_CLS_POLICE
 	if (f->police) {
-		RTA_PUT(skb, TCA_STATS, sizeof(struct tc_stats), &f->police->stats);
+		if (qdisc_copy_stats(skb, &f->police->stats))
+			goto rtattr_failure;
 	}
 #endif
 	return skb->len;
@@ -668,7 +671,6 @@
 	skb_trim(skb, b - skb->data);
 	return -1;
 }
-#endif
 
 struct tcf_proto_ops RSVP_OPS = {
 	NULL,
@@ -682,11 +684,7 @@
 	rsvp_change,
 	rsvp_delete,
 	rsvp_walk,
-#ifdef CONFIG_RTNETLINK
 	rsvp_dump
-#else
-	NULL
-#endif
 };
 
 #ifdef MODULE
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_rsvp6.c linux/net/sched/cls_rsvp6.c
--- ../v2.2.21-ds8/linux/net/sched/cls_rsvp6.c	Thu Apr 30 08:46:59 1998
+++ linux/net/sched/cls_rsvp6.c	Tue Nov 13 03:29:33 2001
@@ -40,3 +40,4 @@
 #define RSVP_OPS	cls_rsvp6_ops
 
 #include "cls_rsvp.h"
+MODULE_LICENSE("GPL");
diff -urN ../v2.2.21-ds8/linux/net/sched/cls_tcindex.c linux/net/sched/cls_tcindex.c
--- ../v2.2.21-ds8/linux/net/sched/cls_tcindex.c	Wed Jul 31 03:00:59 2002
+++ linux/net/sched/cls_tcindex.c	Sun Mar 31 06:18:28 2002
@@ -4,6 +4,7 @@
  * Written 1998,1999 by Werner Almesberger, EPFL ICA
  */
 
+#include <linux/config.h>
 #include <linux/module.h>
 #include <linux/types.h>
 #include <linux/kernel.h>
@@ -75,11 +76,13 @@
 	struct tcindex_filter *f;
 
 	if (p->perfect)
-		return p->perfect[key].res.classid ? p->perfect+key : NULL;
-	if (!p->h) return NULL;
-	for (f = p->h[key % p->hash]; f; f = f->next)
+		return p->perfect[key].res.class ? p->perfect+key : NULL;
+	if (!p->h)
+		return NULL;
+	for (f = p->h[key % p->hash]; f; f = f->next) {
 		if (f->key == key)
 			return &f->result;
+	}
 	return NULL;
 }
 
@@ -92,13 +95,10 @@
 
 	D2PRINTK("tcindex_classify(skb %p,tp %p,res %p),p %p\n",skb,tp,res,p);
 
-/*
-printk("tc_index 0x%x, mask 0x%x, shift %d, res 0x%x\n",skb->tc_index,
-  p->mask,p->shift,(skb->tc_index & p->mask) >> p->shift);
-*/
 	f = lookup(p,(skb->tc_index & p->mask) >> p->shift);
 	if (!f) {
-		if (!p->fall_through) return -1;
+		if (!p->fall_through)
+			return -1;
 		res->classid = TC_H_MAKE(TC_H_MAJ(tp->q->handle),
 		    (skb->tc_index& p->mask) >> p->shift);
 		res->class = 0;
@@ -122,8 +122,14 @@
 
 static unsigned long tcindex_get(struct tcf_proto *tp, u32 handle)
 {
+	struct tcindex_data *p = PRIV(tp);
+	struct tcindex_filter_result *r;
+
 	DPRINTK("tcindex_get(tp %p,handle 0x%08x)\n",tp,handle);
-	return (unsigned long) lookup(PRIV(tp),handle);
+	if (p->perfect && handle >= p->alloc_hash)
+		return 0;
+	r = lookup(PRIV(tp),handle);
+	return r && r->res.class ? (unsigned long) r : 0;
 }
 
 
@@ -164,24 +170,32 @@
 
 	DPRINTK("tcindex_delete(tp %p,arg 0x%lx),p %p,f %p\n",tp,arg,p,f);
 	if (p->perfect) {
-		if (!r->res.classid) return -ENOENT;
-	}
-	else {
+		if (!r->res.class)
+			return -ENOENT;
+	} else {
 		int i;
 		struct tcindex_filter **walk = NULL;
 
-		for (i = 0; !f && i < p->hash; i++)
-			for (walk = p->h+i; !f && *walk; walk = &(*walk)->next)
-				if (&(*walk)->result == r) f = *walk;
-		if (!f) return -ENOENT;
+		for (i = 0; i < p->hash; i++)
+			for (walk = p->h+i; *walk; walk = &(*walk)->next)
+				if (&(*walk)->result == r)
+					goto found;
+		return -ENOENT;
+
+found:
+		f = *walk;
+		tcf_tree_lock(tp); 
 		*walk = f->next;
+		tcf_tree_unlock(tp);
 	}
-	cl = cls_set_class(&r->res.class,0);
-	if (cl) tp->q->ops->cl_ops->unbind_tcf(tp->q,cl);
+	cl = __cls_set_class(&r->res.class,0);
+	if (cl)
+		tp->q->ops->cl_ops->unbind_tcf(tp->q,cl);
 #ifdef CONFIG_NET_CLS_POLICE
 	tcf_police_release(r->police);
 #endif
-	if (f) kfree(f);
+	if (f)
+		kfree(f);
 	return 0;
 }
 
@@ -204,36 +218,47 @@
 	struct tcindex_filter *f;
 	struct tcindex_filter_result *r = (struct tcindex_filter_result *) *arg;
 	struct tcindex_filter **walk;
-	int hash;
+	int hash,shift;
 	__u16 mask;
 
 	DPRINTK("tcindex_change(tp %p,handle 0x%08x,tca %p,arg %p),opt %p,"
 	    "p %p,r %p\n",tp,handle,tca,arg,opt,p,r);
-	if (arg) DPRINTK("*arg = 0x%lx\n",*arg);
-	if (!opt) return 0;
+	if (arg)
+		DPRINTK("*arg = 0x%lx\n",*arg);
+	if (!opt)
+		return 0;
 	if (rtattr_parse(tb,TCA_TCINDEX_MAX,RTA_DATA(opt),RTA_PAYLOAD(opt)) < 0)
 		return -EINVAL;
-	if (!tb[TCA_TCINDEX_HASH-1]) hash = p->hash;
-	else {
+	if (!tb[TCA_TCINDEX_HASH-1]) {
+		hash = p->hash;
+	} else {
 		if (RTA_PAYLOAD(tb[TCA_TCINDEX_HASH-1]) < sizeof(int))
 			return -EINVAL;
 		hash = *(int *) RTA_DATA(tb[TCA_TCINDEX_HASH-1]);
 	}
-	if (!tb[TCA_TCINDEX_MASK-1]) mask = p->mask;
-	else {
+	if (!tb[TCA_TCINDEX_MASK-1]) {
+		mask = p->mask;
+	} else {
 		if (RTA_PAYLOAD(tb[TCA_TCINDEX_MASK-1]) < sizeof(__u16))
 			return -EINVAL;
 		mask = *(__u16 *) RTA_DATA(tb[TCA_TCINDEX_MASK-1]);
 	}
-	if (p->perfect && hash <= mask) return -EBUSY;
-	if ((p->perfect || p->h) && hash > p->alloc_hash) return -EBUSY;
-	p->hash = hash;
-	p->mask = mask;
-	if (tb[TCA_TCINDEX_SHIFT-1]) {
+	if (!tb[TCA_TCINDEX_SHIFT-1])
+		shift = p->shift;
+	else {
 		if (RTA_PAYLOAD(tb[TCA_TCINDEX_SHIFT-1]) < sizeof(__u16))
 			return -EINVAL;
-		p->shift = *(int *) RTA_DATA(tb[TCA_TCINDEX_SHIFT-1]);
+		shift = *(int *) RTA_DATA(tb[TCA_TCINDEX_SHIFT-1]);
 	}
+	if (p->perfect && hash <= (mask >> shift))
+		return -EBUSY;
+	if (p->perfect && hash > p->alloc_hash)
+		return -EBUSY;
+	if (p->h && hash != p->alloc_hash)
+		return -EBUSY;
+	p->hash = hash;
+	p->mask = mask;
+	p->shift = shift;
 	if (tb[TCA_TCINDEX_FALL_THROUGH-1]) {
 		if (RTA_PAYLOAD(tb[TCA_TCINDEX_FALL_THROUGH-1]) < sizeof(int))
 			return -EINVAL;
@@ -242,68 +267,87 @@
 	}
 	DPRINTK("classid/police %p/%p\n",tb[TCA_TCINDEX_CLASSID-1],
 	    tb[TCA_TCINDEX_POLICE-1]);
-	if (!tb[TCA_TCINDEX_CLASSID-1] && !tb[TCA_TCINDEX_POLICE-1]) return 0;
-	if (!p->hash) {
-		if (p->mask < PERFECT_HASH_THRESHOLD) 
-			p->hash = p->mask+1;
-		else
+	if (!tb[TCA_TCINDEX_CLASSID-1] && !tb[TCA_TCINDEX_POLICE-1])
+		return 0;
+	if (!hash) {
+		if ((mask >> shift) < PERFECT_HASH_THRESHOLD) {
+			p->hash = (mask >> shift)+1;
+		} else {
 			p->hash = DEFAULT_HASH_SIZE;
+		}
 	}
 	if (!p->perfect && !p->h) {
 		p->alloc_hash = p->hash;
 		DPRINTK("hash %d mask %d\n",p->hash,p->mask);
-		if (p->hash > p->mask) {
+		if (p->hash > (mask >> shift)) {
 			p->perfect = kmalloc(p->hash*
 			    sizeof(struct tcindex_filter_result),GFP_KERNEL);
-			if (!p->perfect) return -ENOMEM;
-			memset(p->perfect,0,p->hash*
-			    sizeof(struct tcindex_filter_result));
-		}
-		else {
+			if (!p->perfect)
+				return -ENOMEM;
+			memset(p->perfect, 0,
+			       p->hash * sizeof(struct tcindex_filter_result));
+		} else {
 			p->h = kmalloc(p->hash*sizeof(struct tcindex_filter *),
 			    GFP_KERNEL);
-			if (!p->h) return -ENOMEM;
-			memset(p->h,0,p->hash*sizeof(struct tcindex_filter *));
+			if (!p->h)
+				return -ENOMEM;
+			memset(p->h, 0, p->hash*sizeof(struct tcindex_filter *));
 		}
 	}
-	if (handle > p->mask) return -EINVAL;
-	if (p->perfect) r = p->perfect+handle;
-	else {
+	/*
+	 * Note: this could be as restrictive as
+	 * if (handle & ~(mask >> shift))
+	 * but then, we'd fail handles that may become valid after some
+	 * future mask change. While this is extremely unlikely to ever
+	 * matter, the check below is safer (and also more
+	 * backwards-compatible).
+	 */
+	if (p->perfect && handle >= p->alloc_hash)
+		return -EINVAL;
+	if (p->perfect) {
+		r = p->perfect+handle;
+	} else {
 		r = lookup(p,handle);
 		DPRINTK("r=%p\n",r);
-		if (!r) r = &new_filter_result;
+		if (!r)
+			r = &new_filter_result;
 	}
 	DPRINTK("r=%p\n",r);
 	if (tb[TCA_TCINDEX_CLASSID-1]) {
-		unsigned long cl = cls_set_class(&r->res.class,0);
+		unsigned long cl = cls_set_class(tp,&r->res.class,0);
 
-		if (cl) tp->q->ops->cl_ops->unbind_tcf(tp->q,cl);
+		if (cl)
+			tp->q->ops->cl_ops->unbind_tcf(tp->q,cl);
 		r->res.classid = *(__u32 *) RTA_DATA(tb[TCA_TCINDEX_CLASSID-1]);
 		r->res.class = tp->q->ops->cl_ops->bind_tcf(tp->q,base,
-		    r->res.classid);
+							    r->res.classid);
 		if (!r->res.class) {
 			r->res.classid = 0;
 			return -ENOENT;
 		}
         }
 #ifdef CONFIG_NET_CLS_POLICE
-	if (!tb[TCA_TCINDEX_POLICE-1]) r->police = NULL;
-	else {
-		struct tcf_police *police =
-		    tcf_police_locate(tb[TCA_TCINDEX_POLICE-1],NULL);
+	{
+		struct tcf_police *police;
 
+		police = tb[TCA_TCINDEX_POLICE-1] ?
+		    tcf_police_locate(tb[TCA_TCINDEX_POLICE-1],NULL) : NULL;
+		tcf_tree_lock(tp);
 		police = xchg(&r->police,police);
-		synchronize_bh();
+		tcf_tree_unlock(tp);
 		tcf_police_release(police);
-        }
+	}
 #endif
-	if (r != &new_filter_result) return 0;
+	if (r != &new_filter_result)
+		return 0;
 	f = kmalloc(sizeof(struct tcindex_filter),GFP_KERNEL);
-	if (!f) return -ENOMEM;
+	if (!f)
+		return -ENOMEM;
 	f->key = handle;
 	f->result = new_filter_result;
 	f->next = NULL;
-	for (walk = p->h+(handle % p->hash); *walk; walk = &(*walk)->next);
+	for (walk = p->h+(handle % p->hash); *walk; walk = &(*walk)->next)
+		/* nothing */;
 	wmb();
 	*walk = f;
 	return 0;
@@ -313,33 +357,40 @@
 static void tcindex_walk(struct tcf_proto *tp, struct tcf_walker *walker)
 {
 	struct tcindex_data *p = PRIV(tp);
-	struct tcindex_filter *f;
+	struct tcindex_filter *f,*next;
 	int i;
 
 	DPRINTK("tcindex_walk(tp %p,walker %p),p %p\n",tp,walker,p);
-	if (p->perfect)
+	if (p->perfect) {
 		for (i = 0; i < p->hash; i++) {
-			if (!p->perfect[i].res.classid) continue;
-			if (walker->count >= walker->skip)
+			if (!p->perfect[i].res.class)
+				continue;
+			if (walker->count >= walker->skip) {
 				if (walker->fn(tp,
 				    (unsigned long) (p->perfect+i), walker)
 				     < 0) {
 					walker->stop = 1;
 					return;
 				}
+			}
 			walker->count++;
 		}
-	if (!p->h) return;
-	for (i = 0; i < p->hash; i++)
-		for (f = p->h[i]; f; f = f->next) {
-			if (walker->count >= walker->skip)
+	}
+	if (!p->h)
+		return;
+	for (i = 0; i < p->hash; i++) {
+		for (f = p->h[i]; f; f = next) {
+			next = f->next;
+			if (walker->count >= walker->skip) {
 				if (walker->fn(tp,(unsigned long) &f->result,
 				    walker) < 0) {
 					walker->stop = 1;
 					return;
 				}
+			}
 			walker->count++;
 		}
+	}
 }
 
 
@@ -360,16 +411,16 @@
 	walker.skip = 0;
 	walker.fn = &tcindex_destroy_element;
 	tcindex_walk(tp,&walker);
-	if (p->perfect) kfree(p->perfect);
-	if (p->h) kfree(p->h);
+	if (p->perfect)
+		kfree(p->perfect);
+	if (p->h)
+		kfree(p->h);
 	kfree(p);
 	tp->root = NULL;
 	MOD_DEC_USE_COUNT;
 }
 
 
-#ifdef CONFIG_RTNETLINK
-
 static int tcindex_dump(struct tcf_proto *tp, unsigned long fh,
     struct sk_buff *skb, struct tcmsg *t)
 {
@@ -390,23 +441,25 @@
 		RTA_PUT(skb,TCA_TCINDEX_SHIFT,sizeof(p->shift),&p->shift);
 		RTA_PUT(skb,TCA_TCINDEX_FALL_THROUGH,sizeof(p->fall_through),
 		    &p->fall_through);
-	}
-	else {
-		if (p->perfect) t->tcm_handle = r-p->perfect;
-		else {
+	} else {
+		if (p->perfect) {
+			t->tcm_handle = r-p->perfect;
+		} else {
 			struct tcindex_filter *f;
 			int i;
 
 			t->tcm_handle = 0;
-			for (i = 0; !t->tcm_handle && i < p->hash; i++)
+			for (i = 0; !t->tcm_handle && i < p->hash; i++) {
 				for (f = p->h[i]; !t->tcm_handle && f;
-				    f = f->next)
+				     f = f->next) {
 					if (&f->result == r)
 						t->tcm_handle = f->key;
+				}
+			}
 		}
 		DPRINTK("handle = %d\n",t->tcm_handle);
-		if (r->res.class) RTA_PUT(skb,TCA_TCINDEX_CLASSID,4,
-		    &r->res.classid);
+		if (r->res.class)
+			RTA_PUT(skb, TCA_TCINDEX_CLASSID, 4, &r->res.classid);
 #ifdef CONFIG_NET_CLS_POLICE
 		if (r->police) {
 			struct rtattr *p_rta = (struct rtattr *) skb->tail;
@@ -422,13 +475,10 @@
 	return skb->len;
 
 rtattr_failure:
-	skb_trim(skb,b-skb->data);
+	skb_trim(skb, b - skb->data);
 	return -1;
 }
 
-#endif
-
-
 struct tcf_proto_ops cls_tcindex_ops = {
 	NULL,
 	"tcindex",
@@ -441,22 +491,19 @@
 	tcindex_change,
 	tcindex_delete,
 	tcindex_walk,
-#ifdef CONFIG_RTNETLINK
 	tcindex_dump
-#else
-	NULL
-#endif
 };
 
+
 #ifdef MODULE
 int init_module(void)
 {
 	return register_tcf_proto_ops(&cls_tcindex_ops);
 }
 
-void cleanup_module(void)
+void cleanup_module(void) 
 {
 	unregister_tcf_proto_ops(&cls_tcindex_ops);
 }
 #endif
-
+MODULE_LICENSE("GPL");
